﻿Option Strict On
Option Explicit On

Public Class Form1
    Private Sub target_TextChanged(sender As Object, e As EventArgs) Handles target.TextChanged
        If target.TextLength > 0 Then
            GroupBox1.Enabled = True
            GroupBox2.Enabled = True
            Button2.Enabled = True
        Else
            GroupBox1.Enabled = False
            GroupBox2.Enabled = False
            Button2.Enabled = False
        End If
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim sfd As New SaveFileDialog
        sfd.Title = "Select destination path:"
        If sfd.ShowDialog = DialogResult.OK And sfd.FileName <> Nothing Then
            destination.Text = sfd.FileName
        Else
            destination.Clear()
        End If
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        If Not destination.TextLength > 0 And target.TextLength > 0 Then
            MessageBox.Show("Please enter: Direct-Downloadlink, Destination-Path", "ERROR!", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            percentage.Text = "0%"
            progress.Value = 0
            If CheckBox5.Checked Then
                ActionController.ResponsiveSleep(CInt(NumericUpDown1.Value))
                If Not DownloadController.DownloadFrom(target.Text, destination.Text) Then
                    MessageBox.Show("Download failed!", "ERROR!", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Else
                    Button2.Enabled = False
                    Button3.Enabled = True
                End If
            Else
                If Not DownloadController.DownloadFrom(target.Text, destination.Text) Then
                    MessageBox.Show("Download failed!", "ERROR!", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Else
                    Button2.Enabled = False
                    Button3.Enabled = True
                End If
            End If
        End If
    End Sub


    Private Sub percentage_TextChanged(sender As Object, e As EventArgs) Handles percentage.TextChanged
        If percentage.Text = "100%" Then
            MessageBox.Show("Download was successfully!", "OK!", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        If DownloadController.CancelDownloadFile Then
            Button3.Enabled = False
            Button2.Enabled = True
            MessageBox.Show("Download was successfully canceled!", "OK!", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            MessageBox.Show("Unexpected Error!", "ERROR!", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub CheckBox5_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox5.CheckedChanged
        If CheckBox5.Checked Then
            NumericUpDown1.Enabled = True
        Else
            NumericUpDown1.Enabled = False
        End If
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked Then
            DownloadController.UnpackFiles = True
        Else
            DownloadController.UnpackFiles = False
        End If
    End Sub
End Class
