﻿Option Strict On
Option Explicit On

Public Class ActionController

    'Credits to https://docs.microsoft.com/ & others.
    Public Shared Sub UnZip(ByVal destination As String, ByVal inputZip As String)
        Dim sc As New Shell32.Shell()
        IO.Directory.CreateDirectory(destination)
        Dim output As Shell32.Folder = sc.NameSpace(destination)
        Dim input As Shell32.Folder = sc.NameSpace(inputZip)
        output.CopyHere(input.Items, 4)
    End Sub

    Public Shared Function CopyFile(ByVal source As String, ByVal destination As String) As Boolean
        Try
            IO.File.Copy(source, destination)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Shared Function MoveFile(ByVal source As String, ByVal destination As String) As Boolean
        Try
            IO.File.Move(source, destination)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Shared Function DeleteFile(ByVal filename As String) As Boolean
        Try
            IO.File.Delete(filename)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    'Credits to https://stackoverflow.com/
    Public Shared Sub ResponsiveSleep(ByVal iMilliSeconds As Integer)
        Dim i As Integer, iHalfSeconds As Integer = CInt(iMilliSeconds / 500)
        For i = 1 To iHalfSeconds
            Threading.Thread.Sleep(500) : Application.DoEvents()
        Next i
    End Sub

End Class
